SystemOrganization addCategory: #'OpenCourses-Tests'!
SystemOrganization addCategory: #OpenCourses!

Object subclass: #DidacticMaterial
	instanceVariableNames: 'file title description authors owner licence creationDate lastUploadDate type tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors
	"Answer the value of authors"

	^ authors! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate
	"Answer the value of creationDate"

	^ creationDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate: anObject
	"Set the value of creationDate"

	creationDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:13'!
description
	"Answer the value of description"

	^ description! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:13'!
description: anObject
	"Set the value of description"

	description := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file
	"Answer the value of file"

	^ file! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file: anObject
	"Set the value of file"

	file := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate
	"Answer the value of lastUploadDate"

	^ lastUploadDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate: anObject
	"Set the value of lastUploadDate"

	lastUploadDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence
	"Answer the value of licence"

	^ licence! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner
	"Answer the value of owner"

	^ owner! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags
	"Answer the value of tags"

	^ tags! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title
	"Answer the value of title"

	^ title! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title: anObject
	"Set the value of title"

	title := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type
	"Answer the value of type"

	^ type! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type: anObject
	"Set the value of type"

	type := anObject! !

Object subclass: #FakeFile
	instanceVariableNames: 'title contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents
	"Answer the value of contents"

	^ contents! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents: anObject
	"Set the value of contents"

	contents := anObject! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title
	"Answer the value of title"

	^ title! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #MaterialManager
	instanceVariableNames: 'materialList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!MaterialManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 17:06'!
initialize
	super initialize.
	materialList := Set new.! !

!MaterialManager methodsFor: 'private' stamp: 'jsa 5/11/2013 17:04'!
materialList
	^ materialList! !

!MaterialManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 17:28'!
submitMaterial: submittedFile title: title authors: authorsList description: description type: type licence: licence tags: tags
	| material now user|
	now := TimeStamp now.
	user := Session user.
	material := DidacticMaterial new file: submittedFile; title: title; authors: authorsList; description: description; type: type; licence: licence; tags: tags; creationDate: now; lastUploadDate: now; owner: user.
	materialList add: material! !

Object subclass: #Session
	instanceVariableNames: ''
	classVariableNames: 'CurrentUser'
	poolDictionaries: ''
	category: 'OpenCourses'!

!Session class methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:58'!
user
	^CurrentUser! !

!Session class methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:58'!
user: aUser
	CurrentUser := aUser! !

Object subclass: #User
	instanceVariableNames: 'name password email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!User methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 17:15'!
= aUser 
	^ self email = aUser email! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email
	"Answer the value of email"

	^ email! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email: anObject
	"Set the value of email"

	email := anObject! !

!User methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 17:33'!
hash
	^ email hash! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:34'!
name
	"Answer the value of name"
	^ name! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:31'!
name: anObject
	"Set the value of name"

	name := anObject! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password
	"Answer the value of password"

	^ password! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password: anObject
	"Set the value of password"

	password := anObject! !

Object subclass: #UserManager
	instanceVariableNames: 'userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!UserManager methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 17:08'!
hasUser: aUser 
	^ userList includes: aUser! !

!UserManager methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 17:26'!
initialize
	super initialize.
	userList := Set new! !

!UserManager methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:59'!
login: email password: password 
	| user registeredUser |
	user := User new email: email;
				 password: password.
	registeredUser := userList
				like: user
				ifAbsent: [Error signal: 'User/Password incorrect!!'].
	user password = registeredUser password
		ifTrue: [Session user: registeredUser]
		ifFalse: [Error signal: 'User/Password incorrect!!']! !

!UserManager methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 17:56'!
registerNewUser: name password: password email: email 
	| newUser |
	newUser := User new name: name;
				 password: password;
				 email: email.
	(userList includes: newUser)
		ifFalse: [userList add: newUser]
		ifTrue: [Error signal: 'Duplicated user']! !

!UserManager methodsFor: 'accessing' stamp: 'cmb 5/10/2013 17:28'!
userList
	"Answer the value of userList"

	^ userList! !

!UserManager methodsFor: 'accessing' stamp: 'cmb 5/10/2013 17:28'!
userList: anObject
	"Set the value of userList"

	userList := anObject! !

TestCase subclass: #MaterialManagerTest
	instanceVariableNames: 'emptyMaterialManager nonEmptyMaterialManager authorsList submittedFile tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 17:32'!
setUp
	authorsList := OrderedCollection new add: 'author1'; add: 'author2'.
	submittedFile := FakeFile new title: 'file title'; contents: (ByteArray new).
	tags := SortedCollection new add: 'OOP'; add: 'Smalltalk'.
	emptyMaterialManager := MaterialManager new.
	nonEmptyMaterialManager := MaterialManager new submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.! !

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 17:32'!
testSubmitMaterial
	emptyMaterialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (emptyMaterialManager materialList select: [:material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 17:33'!
testSubmitMaterialAutomaticFields
	| loggedUser now maxDuration|
	loggedUser := User new email: 'user@email.com'.
	Session user: loggedUser.
	maxDuration := Duration seconds: 1.
	now := TimeStamp now.
	emptyMaterialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (emptyMaterialManager materialList select: [:material | material owner = loggedUser and: material creationDate - now <  maxDuration and: material lastUploadDate - now < maxDuration]) size == 1.! !

TestCase subclass: #UserManagerTest
	instanceVariableNames: 'emptyUserManager nonEmptyUserManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:33'!
setUp
	emptyUserManager := UserManager new.
	nonEmptyUserManager := UserManager new.
	nonEmptyUserManager registerNewUser: 'john' password: '123admin' email: 'johnadmin@me.com'.! !

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:57'!
testLogin
	| loggedUser |
	self
		should: [nonEmptyUserManager login: 'emailDoesntExist' password: '123admin']
		raise: Error.
	self
		should: [nonEmptyUserManager login: 'johnadmin@me.com' password: 'wrongPassword']
		raise: Error.
	loggedUser := User new email: 'johnadmin@me.com'.
	self
		should: [nonEmptyUserManager login: 'johnadmin@me.com' password: '123admin'.
			Session user = loggedUser]! !

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:34'!
testRegisterNewUser
	| createdUser |
	createdUser := User new name: 'john';
				 password: '123admin';
				 email: 'johnadmin@me.com'.
	self
		shouldnt: [emptyUserManager hasUser: createdUser].
	emptyUserManager
		registerNewUser: 'john'
		password: '123admin'
		email: 'johnadmin@me.com'.
	self
		assert: (emptyUserManager hasUser: createdUser)! !

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:35'!
testTryToRegisterAnAlreadyRegisteredUser
	self
		should: [nonEmptyUserManager
				registerNewUser: 'jon'
				password: '123admin321'
				email: 'johnadmin@me.com']
		raise: Error! !
